----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
--  
-- Create Date:    20:10:52 12/09/2008 
-- Design Name: 
-- Module Name:    top - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;
 
entity top is
    Port ( CLKIN : in  STD_LOGIC;
           CHA : out  STD_LOGIC_VECTOR (5 downto 0);
           CHB : out  STD_LOGIC_VECTOR (5 downto 0);
           CHC : out  STD_LOGIC_VECTOR (5 downto 0));
end top;

architecture Behavioral of top is
signal CHANA  : std_logic_vector(7 downto 0);
signal CHANB  : std_logic_vector(7 downto 0);
signal CHANC  : std_logic_vector(7 downto 0);
signal PHASEA : std_logic_vector(11 downto 0);
signal PHASEB : std_logic_vector(11 downto 0);
signal PHASEC : std_logic_vector(11 downto 0);
signal COUNT  : std_logic_vector(31 downto 0);
signal CLK    : std_logic;


component SINTFULL 
port (
    CLK   : in  std_logic; 
    PHASE : in  std_logic_vector(11 downto 0); 
    AMP   : out std_logic_vector(7 downto 0)
    ); 
end component; 

begin
  
   CLK <= CLKIN;

    U1: SINTFULL port map( CLK, PHASEA, CHANA );
    U2: SINTFULL port map( CLK, PHASEB, CHANB );
    U3: SINTFULL port map( CLK, PHASEC, CHANC );

    process (CLK)
    begin
        if CLK'event and CLK='1' then
             COUNT  <= COUNT + 4294;  -- add 4294 for 50Hz 

             PHASEA <= COUNT(31 downto 20);
             PHASEB <= COUNT(31 downto 20)+"01010101010101010101010101010101";
             PHASEC <= COUNT(31 downto 20)+"10101010101010101010101010101010";
 
             CHA   <= CHANA(7 downto 2);
             CHB   <= CHANB(7 downto 2);
             CHC   <= CHANC(7 downto 2);
         end if;
    end process;

end Behavioral;

